<?php
/*
Copyright (c) 2006 Yasuo Ohgaki All Rights Reserved

This file is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.
 */

// このファイルをブラウザから読み込まれても無害ですが、本来アクセスされるべきファイルは
// ドキュメントルート以下に置くべきてない。

// config.phpが読み込まれた事を示す定数
define('CONFIG', TRUE);

// パス設定
$dir = dirname(__FILE__); // このファイルのディレクトリを基準にする。
define('BASEDIR', $dir);

// 便宜上 /lib, /tpl, /dat ディレクトリに設定。本来は外部からアクセス不可の場所に配置
define('LIBDIR',  BASEDIR . '/lib/');
define('TPLDIR',  BASEDIR . '/tpl/');
define('DATADIR', BASEDIR . '/dat/');

// アプリケーションのパス。Webサーバのドキュメントルートからパス。
// http://example.com/bbs/ にインストールされている場合は/bbs/に設定
define('URI_PATH', '/');

// テスト用
define('DEBUG', 0);        // デバッグオプション 定義するとデバッグモード。運用時は未定義に設定。
                           // 2に設定するとバリデーションとエラーチェックの動作がわかる。
define('CONFIG-CHECK', 1); // php.ini設定の確認を行うか設定

// セッション管理関連設定
define('LOGIN_PATH',   URI_PATH .'login/'); // AUTOLOGINクッキーのパス
define('SESS_EXPIRES', 1800); // 30分で無効
define('SESS_REGEN',   300);  // 5分でセッションIDを再生成


// 自動ログイン関連設定
define('AUTOLOGIN_EXPIRE', 3600*24*1); // 1日で期限切れ

require_once LIBDIR . 'error.lib.php';   // エラー処理
require_once LIBDIR . 'session.lib.php'; // セッション管理

// エラーハンドラに処理させるためにerror.php読み込み後に確認
if ($_SERVER['SCRIPT_FILENAME'] == __FILE__) {
	trigger_error('config.phpが直接リクエストされました。', E_USER_ERROR);
}

require_once LIBDIR . 'security.lib.php';  // セキュリティ対策関数
require_once LIBDIR . 'auth.class.php';    // 認証
require_once LIBDIR . 'database.class.php';// データベース
require_once LIBDIR . 'bbs.class.php';     // BBS本体

// サーバー環境のチェック
if (defined('CONFIG-CHECK')) {
	require_once LIBDIR . 'config-check.lib.php';
}


// mbstringの設定
mb_language('ja');                           // 日本語環境に設定 
mb_internal_encoding('UTF-8');               // 内部エンコーディングの指定
mb_regex_encoding('UTF-8');
mb_detect_order('eucjp-win,sjis-win,UTF-8'); // 自動認識順序 - 現在のWeb環境ではほぼ必要ない。このプログラムはUTF-8前提。

ini_set('default_mime_type', 'text/plain');  // デフォルトはtext/html。XSSフェイルセーフ対策にtext/plainに設定
ini_set('default_charset', 'UTF-8');         // 出力エンコーディングの設定 - 設定しないとエンコーディングを利用
                                             // した攻撃に脆弱になる
ini_set('error_reporting', E_ALL);           // エラー設定 - E_STRICT以外を設定。エラーハンドラで全て捕捉

// デバッグ用
function d($v) {
	echo '<pre>';var_dump($v);echo '</pre>';
}

function dd($v) {
	echo '<pre>';
	var_dump($v);
	debug_print_backtrace();
	echo '</pre>';
	exit;
}
