<?php
/*
Copyright (c) 2006 Yasuo Ohgaki All Rights Reserved

This file is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.
 */

// SQLiteデータベースを初期化します。
//die('データベースを初期化するにはこの行をコメントアウトしてください。FILE:'.__FILE__.' LINE:'.__LINE__);


// 設定ファイルの読み込み
require_once '../../config.php';

// 通常のエラーハンドラを使用
restore_error_handler();

$db = new PDO('sqlite:'.MAINDB);
if (!$db) {
	die('SQLiteデータベースファイルが開けません。'.PHP_EOL);
}

echo 'データベースを作成：'.MAINDB.PHP_EOL;
$ddls = array("DROP TABLE form_id;","DROP TABLE user;","DROP TABLE thread;","DROP TABLE autologin");
foreach($ddls as $ddl) {
	if (!$db->query($ddl)) {
		echo 'テーブルの削除に失敗しました。'.$ddl.PHP_EOL;
	}
}

// FORM ID database
$ddl = "CREATE TABLE form_id (" .
		"sha1 TEXT PRIMARY KEY," .
		"created TEXT NOT NULL" .
		");";

if (!$db->query($ddl)) {
	echo 'form_idテーブルの作成に失敗しました。'.PHP_EOL;
} else {
	echo 'form_idテーブルを作成しました。'.PHP_EOL;
}


// BBS database
$ddl = "CREATE TABLE user (" .
		"id INTEGER PRIMARY KEY," .
		"username TEXT UNIQUE NOT NULL," .
		"password TEXT NOT NULL," .
		"lastlogin INTEGER DEFAULT 0," .
		"autologin TEXT" .
		");";

if (!$db->query($ddl)) {
	echo 'userテーブルの作成に失敗しました。'.PHP_EOL;
} else {
	echo 'userテーブルを作成しました。'.PHP_EOL;
}

$ddl = "CREATE TABLE thread (" .
		"id INTEGER PRIMARY KEY, " .
		"title TEXT NOT NULL," .
		"message TEXT NOT NULL," .
		"created TEXT NOT NULL" .
		");";

if (!$db->query($ddl)) {
	echo 'threadテーブルの作成に失敗しました。'.PHP_EOL;
} else {
	echo 'threadテーブルを作成しました。'.PHP_EOL;
}



$ddl = "CREATE TABLE autologin (" .
		"id INTEGER PRIMARY KEY, " .
		"key TEXT NOT NULL, " .
		"username TEXT NOT NULL, " .
		"created DEFAULT CURRENT_TIMESTAMP" .
		");";

if (!$db->query($ddl)) {
	echo 'messageテーブルの作成に失敗しました。'.PHP_EOL;
} else {
	echo 'messageテーブルを作成しました。'.PHP_EOL;
}

// BBS data

$sql = "INSERT INTO user " .
		"(username, password) VALUES " .
		"('guest', '". sha1('guest') ."')";
		
if (!$db->exec($sql)) {
	echo 'ユーザー：guest パスワード:guest の作成に失敗しました。'.PHP_EOL;
} else {
	echo 'ユーザー：guest パスワード:guest を作成しました。'.PHP_EOL;
}


