<?php
/*
Copyright (c) 2006 Yasuo Ohgaki All Rights Reserved

This file is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.
 */

// 強制ブラウズ対策
if (!defined('CONFIG')) {
	error_log(
		'直接アクセスを検知しました。 ファイル: '. __FILE__.' 行:'.__LINE__.
		' IP: '. $_SERVER['REMOTE_ADDR'] .' AGENT: '. $_SERVER['HTTP_USER_AGENT']);
	die('このファイルは直接参照できません。');// 確実に実行を終了する
}

// 出力バッファを開始 - エラー処理用にheader, html出力を全てバッファする
ob_start();

// エラーハンドラを登録 - 本来はE_STRICTも処理すべき
set_error_handler('error_handler', E_ALL);

// set_exception_handler()で例外も補足した方が良いが、catchしない例外は致命的エラーとなるので省略
// エラーハンドラの定義
function error_handler($errno, $errstr, $errfile, $errline)
{
	// エラー番号とエラーレベルのマッピング
	$errlev = array(
		E_USER_ERROR => 'FATAL',
		E_ERROR => 'FATAL',
		E_RECOVERABLE_ERROR => 'FATAL',
		E_USER_WARNING => 'WARNING',
		E_WARNING => 'WARNING',
		E_USER_NOTICE => 'NOTICE',
		E_NOTICE => 'NOTICE'
	);

	// スタックトレースを取得
	ob_start();
	@debug_print_backtrace();
	$trace = ob_get_clean();

	// $_GET, $_POST, $_COOKIEはconfig.phpで定義されている
	if (empty($_SESSION)) {
		$_SESSION = array();
	}

	// メッセージの作成
	$msg =
		'DATE:  ' . date('Y-m-d H:i:s') . PHP_EOL .
		'TYPE:  ' . (empty($errlev[$errno]) ? 'OTHER' : $errlev[$errno]) . PHP_EOL .
		'FILE:  ' . $errfile . PHP_EOL .
		'LINE:  ' . $errline . PHP_EOL .
		'ERROR: ' . $errstr . PHP_EOL .
		'-----------------------------------------' . PHP_EOL .
		$trace . PHP_EOL .
		'----------------$_GET-------------------------' . PHP_EOL .
		print_r($_GET, true) . PHP_EOL .
		'----------------$_POST-------------------------' . PHP_EOL .
		print_r($_POST, true) . PHP_EOL .
			'----------------$_COOKIE-------------------------' . PHP_EOL .
		print_r($_COOKIE, true) . PHP_EOL .
		'----------------$_SESSION-------------------------' . PHP_EOL .
		print_r($_SESSION, true) . PHP_EOL .
		'----------------$_SERVER-------------------------' . PHP_EOL .
		print_r($_SERVER, true) . PHP_EOL;
	// エラーを記録
	error_log($msg);

	//デバッグの場合はエラーを出力。
	if (DEBUG) {
		echo '<pre>'. htmlspecialchars($msg) . '</pre>';
	} else {
		ob_clean(); // 出力バッファをクリア
		require TPLDIR . 'error.php';
	}
	// 全てのエラーは致命的なエラーとして処理
	exit;
}

