<?php
/*
Copyright (c) 2006 Yasuo Ohgaki All Rights Reserved

This file is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.
 */

// 強制ブラウズ対策
if (!defined('CONFIG')) {
	error_log(
		'直接アクセスを検知しました。 ファイル: '. __FILE__.' 行:'.__LINE__.
		' IP: '. $_SERVER['REMOTE_ADDR'] .' AGENT: '. $_SERVER['HTTP_USER_AGENT']);
	die('このファイルは直接参照できません。');// 確実に実行を終了する
}

if (!defined('SESS_EXPIRES')) define('SESS_EXPIRES', 7200); // 2時間で無効化
if (!defined('SESS_REGEN'))  define('SESS_REGEN', 3600);   // 1時間でセッションIDを再生成

ini_set('session.name', 'BBS');                // セッション名
ini_set('session.use_cookies', 'on');          // セッション初期化前なら設定可能
ini_set('session.cookie_httponly', 'on');      // JavaScriptからクッキーにアクセスさせない
ini_set('session.bug_compat_42', 'off');       // $_SESSIONのみを利用するなら不必要
ini_set('session.hash_function', 1);           // MD5（デフォルト）よりSHA1
ini_set('session.hash_bits_per_character', 4); // 0-9, a-f の文字が使用される
ini_set('session.cache_limiter', 'nocache');   // キャッシュ無効化

// クッキーの有効期限を0秒(セッション中のみ有効なクッキー）、HttpOnlyを設定。本来はアプリのパスを設定し限定した方が良い。
session_set_cookie_params(0, '/', '', false, true);
if (!session_start()) {
	trigger_error('SESSIONは開始されています。', E_USER_ERROR);
}

// セッションデータの初期化

// PHP7のセッションからlazy_writeに対応するため、タイムスタンプを1分ごとに更新
// PHP7からできるだけ$_SESSIONを更新しない方が効率が良い
$current_time = (int)(time()/60);

if (empty($_SESSION['access'])) {
	$_SESSION['access'] = $current_time;
	$_SESSION['AUTH'] = null;
} else {
	if ($_SESSION['access'] < $current_time - SESS_EXPIRES) {
		// セッションは無効
		if (!session_destroy()) {
			error_log('セッションの削除に失敗しました。');
		}
		session_regenerate_id();
		header('Location: http://'. $_SERVER['HTTP_HOST'] . URI_PATH .'login/');
		exit;
	}
	if ($_SESSION['access'] < $current_time - SESS_REGEN) {
		// セッションIDの再生成
		if (!session_regenerate_id(true)) {
			trigger_error('セッションIDの再生成に失敗しました。', E_USER_NOTICE);
		}
	}
	$_SESSION['access'] = $current_time; // タイプスタンプの更新
}
