<?php
/*
Copyright (c) 2006 Yasuo Ohgaki All Rights Reserved

This file is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.
 */

// 設定ファイルの読み込み
require_once '../config.php';

// MIMEタイプを設定(config.phpでtext/plainと設定)
ini_set('default_mime_type', 'text/html');

// アプリケーションの初期化 - 認証確認なし
$bbs = new BBS(false);
// アクションの設定
$bbs->GetAction('login');

// アクションを実行
switch($bbs->action) {
	case 'login_form':
		// バリデーションと入力ミスの処理
		$errors = $bbs->ValidateInputs();
		if (empty($errors)) {
			autologin($bbs);
		}
		require TPLDIR . 'login_form.php';
		break;

	case 'login':
		// バリデーションと入力ミスの処理
		$errors = $bbs->ValidateInputs();
		if (empty($errors)) {
			$errors[] = login($bbs);
		}
		require TPLDIR . 'login_form.php';
		break;

	case 'logoff':
		// バリデーションと入力ミスの処理
		$errors = $bbs->ValidateInputs();
		// ログオフは常に呼び出す
		$errors[] = logoff($bbs);
		require TPLDIR . 'login_form.php';
		break;

	default:
		trigger_error('無効なアクション');
}

exit; // 明示的に終了。フェイルセーフ

function login($bbs) {
	if ($bbs->Login($_POST['username'], $_POST['password'])) {
		// ログイン成功
		header('Location: http://'. $_SERVER['HTTP_HOST'] . URI_PATH . 'thread.php');
		ob_get_clean();exit;
	} else {
		return '正しいユーザ名とパスワードを入力してください。';
	}
}

function logoff($bbs) {
	if ($bbs->Logoff()) {
		return 'ログオフしました。';
	} else {
		return '既にログオフしています。';
	}
}

function autologin($bbs) {
	if (empty($_COOKIE['AUTOLOGIN'])) {
		return;
	}
	// クッキーは検証されていないのでここでチェック
	validate_sha1($_COOKIE['AUTOLOGIN']);
	if ($bbs->AutoLogin($_COOKIE['AUTOLOGIN'])) {
		// ログイン成功
		header('Location: http://'. $_SERVER['HTTP_HOST'] . URI_PATH . 'thread.php');
		ob_get_clean();exit;
	}
}

