<?php
/*
Copyright (c) 2006 Yasuo Ohgaki All Rights Reserved

This file is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.
 */

// 設定ファイルの読み込み
require_once 'config.php';

// MIMEタイプを設定(config.phpでtext/plainと設定)
ini_set('default_mime_type', 'text/html');

// アプリケーションの初期化 - 認証確認
$bbs = new BBS(true);
// アクションの設定
$bbs->GetAction('thread');

// アクションを実行
switch($bbs->action) {
	case 'thread_list':
		// バリデーションと入力ミスの処理
		$errors = $bbs->ValidateInputs();
		if (empty($errors)) {
			$row_format = '<tr><td>%s</td><td>%s</td></tr>'.PHP_EOL;
			$thread_list = get_threads($bbs, $row_format);
		}
		require TPLDIR . 'thread_list.php';
		break;

	case 'thread_view':
		// バリデーションと入力ミスの処理
		$errors = $bbs->ValidateInputs();
		if (empty($errors)) {
			$r = get_thread($bbs, $_GET['thread_id']);
		}
		require TPLDIR . 'thread_view.php';
		break;

	default:
		trigger_error('無効なアクション');
}

exit; // 明示的に終了。フェイルセーフ

function get_threads($bbs, $format) {
	$threads = $bbs->GetThreads();
	if (!$threads) {
		$list = sprintf($format, '投稿がありません。', '');
	} else {
		$list = '';
		foreach($threads as $t) {
			$link = '<a href="'. URI_PATH .'thread.php?action=thread_view&amp;thread_id='. rawurlencode($t['id']) .'">'. html($t['title']) .'</a>';
			$list .= sprintf($format, $link,  html($t['created']));
		}
		$list;
	}
	return $list;
}

function get_thread($bbs, $id) {
	$record = $bbs->GetThread($id);
	if (is_array($record)) {
		return $record;
	} else {
		trigger_error('スレッドがありません。');
	}
}
