<?php
/*
Copyright (c) 2006 Yasuo Ohgaki All Rights Reserved

This file is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.
 */

// 設定ファイルの読み込み
require_once 'config.php';

// MIMEタイプを設定(config.phpでtext/plainと設定)
ini_set('default_mime_type', 'text/html');

// アプリケーションの初期化 - 認証確認
$bbs = new BBS(true);
// アクションの設定
$bbs->GetAction('thread_create');

// アクションを実行
switch($bbs->action) {
	case 'thread_edit':
		// バリデーションと入力ミスの処理
		$errors = $bbs->ValidateInputs();
		if (empty($errors)) {
			$form_id = $bbs->GetFormID();
		}
		require TPLDIR . 'thread_create.php';
		break;

	case 'thread_submit':
		// バリデーションと入力ミスの処理
		$errors = $bbs->ValidateInputs();
		// form_idを確認し削除
		if (empty($errors) && $bbs->CheckFormID($_POST['form_id'])) {
			$bbs->CreateThread($_POST['title'], $_POST['message']);
			header('Location: http://'. $_SERVER['HTTP_HOST'] . URI_PATH .'thread.php?action=thread_list');
			ob_get_clean();
			exit;
		} else {
			require TPLDIR . 'error.php';
			exit;
		}
		break;

	default:
		trigger_error('無効なアクション');
}

